from Namespace import *
from DeploymentPolicy import DeploymentPolicy

class DeploymentTool(UniqueObject, Folder):

    id = 'portal_deployment'
    
    meta_type = 'Deployment Tool'
    
    security = ClassSecurityInfo()
    security.declareObjectProtected(CMFCorePermissions.ManagePortal)

    manage_options = (
        
        {'label':'Overview',
         'action':'overview'},

        {'label':'Policies',
         'action':'manage_main'}
        )


    overview = DTMLFile('ui/ToolOverview', globals())
    addPolicyForm = DTMLFile('ui/ToolAddPolicyForm', globals())

    all_meta_types = (
        {'name':DeploymentPolicy.meta_type,
         'action':'addPolicyForm'},
        )

    security.declareProtected(CMFCorePermissions.ManagePortal, 'addPolicy')
    def addPolicy(self, policy_id, policy_title, REQUEST=None):
        """  """

        self._setObject(policy_id, DeploymentPolicy(policy_id))
        
        if REQUEST is not None:
            policy = self._getOb(policy_id)
            REQUEST.RESPONSE.redirect(policy.absolute_url()+'/manage_main')

    security.declareProtected(CMFCorePermissions.ManagePortal, 'removePolicy')        
    def removePolicy(self, policy_id):
        self._delObject(policy_id)

    security.declareProtected(CMFCorePermissions.ManagePortal, 'getPolicy')
    def getPolicy(self, policy_id):
        return self._getOb(policy_id)



