import DefaultConfiguration 

from ContentOrganization import ContentOrganization
from ContentIdentification import ContentIdentification
from ContentMastering import ContentMastering
from ContentDeployment import ContentDeployment

def add_structure(policy):

    ob = ContentOrganization(DefaultConfiguration.ContentOrganization)
    policy._setObject(DefaultConfiguration.ContentOrganization, ob)

def add_identification(policy):

    ob = ContentIdentification(DefaultConfiguration.ContentIdentification)
    policy._setObject(DefaultConfiguration.ContentIdentification, ob)

def add_mastering(policy):

    ob = ContentMastering(DefaultConfiguration.ContentMastering)
    policy._setObject(DefaultConfiguration.ContentMastering, ob)

def add_deployment(policy):

    ob = ContentDeployment(DefaultConfiguration.ContentDeployment)
    policy._setObject(DefaultConfiguration.ContentDeployment, ob)
    
_funcs = [add_structure, add_identification, add_mastering, add_deployment]

def install(deployment_policy):
    global _funcs
    for f in _funcs:
        f(deployment_policy)

    
